// This file has been generated by Py++.

#include "boost/python.hpp"
#include "BasicVector3D.h"
#include "Experiment.h"
#include "FormFactorCrystal.h"
#include "FormFactorCylinder.h"
#include "FormFactorDecoratorDebyeWaller.h"
#include "FormFactorFullSphere.h"
#include "FormFactorGauss.h"
#include "FormFactorLorentz.h"
#include "FormFactorPrism3.h"
#include "FormFactorPyramid.h"
#include "FormFactorSphereGaussianRadius.h"
#include "GISASExperiment.h"
#include "HomogeneousMaterial.h"
#include "IClusteredParticles.h"
#include "ICompositeSample.h"
#include "IFormFactor.h"
#include "IInterferenceFunction.h"
#include "InterferenceFunctionNone.h"
#include "InterferenceFunction1DParaCrystal.h"
#include "IMaterial.h"
#include "IParameterized.h"
#include "ISample.h"
#include "ISampleBuilder.h"
#include "ISelectionRule.h"
#include "ISingleton.h"
#include "Lattice.h"
#include "LatticeBasis.h"
#include "Layer.h"
#include "LayerDecorator.h"
#include "LayerRoughness.h"
#include "MaterialManager.h"
#include "MesoCrystal.h"
#include "MultiLayer.h"
#include "Particle.h"
#include "Crystal.h"
#include "ParticleDecoration.h"
#include "OpticalFresnel.h"
#include "ParameterPool.h"
#include "ParticleInfo.h"
#include "DiffuseParticleInfo.h"
#include "PythonOutputData.h"
#include "PythonPlusplusHelper.h"
#include "Transform3D.h"
#include "Units.h"
#include "Types.h"
#include "PythonInterface_classes_2.h"

namespace bp = boost::python;

struct FormFactorPyramid_wrapper : FormFactorPyramid, bp::wrapper< FormFactorPyramid > {

    FormFactorPyramid_wrapper(double height, double half_side, double alpha )
    : FormFactorPyramid( height, half_side, alpha )
      , bp::wrapper< FormFactorPyramid >(){
        // constructor
    
    }

    virtual ::FormFactorPyramid * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->FormFactorPyramid::clone(  );
        }
    }
    
    ::FormFactorPyramid * default_clone(  ) const  {
        return FormFactorPyramid::clone( );
    }

    virtual double getHeight(  ) const  {
        if( bp::override func_getHeight = this->get_override( "getHeight" ) )
            return func_getHeight(  );
        else{
            return this->FormFactorPyramid::getHeight(  );
        }
    }
    
    double default_getHeight(  ) const  {
        return FormFactorPyramid::getHeight( );
    }

    virtual int getNumberOfStochasticParameters(  ) const  {
        if( bp::override func_getNumberOfStochasticParameters = this->get_override( "getNumberOfStochasticParameters" ) )
            return func_getNumberOfStochasticParameters(  );
        else{
            return this->FormFactorPyramid::getNumberOfStochasticParameters(  );
        }
    }
    
    int default_getNumberOfStochasticParameters(  ) const  {
        return FormFactorPyramid::getNumberOfStochasticParameters( );
    }

    virtual void createDistributedFormFactors( ::std::vector< IFormFactor* > & form_factors, ::std::vector< double > & probabilities, ::size_t nbr_samples ) const  {
        if( bp::override func_createDistributedFormFactors = this->get_override( "createDistributedFormFactors" ) )
            func_createDistributedFormFactors( boost::ref(form_factors), boost::ref(probabilities), nbr_samples );
        else{
            this->IFormFactor::createDistributedFormFactors( boost::ref(form_factors), boost::ref(probabilities), nbr_samples );
        }
    }
    
    void default_createDistributedFormFactors( ::std::vector< IFormFactor* > & form_factors, ::std::vector< double > & probabilities, ::size_t nbr_samples ) const  {
        IFormFactor::createDistributedFormFactors( boost::ref(form_factors), boost::ref(probabilities), nbr_samples );
    }

    virtual ::ParameterPool * createParameterTree(  ) const  {
        if( bp::override func_createParameterTree = this->get_override( "createParameterTree" ) )
            return func_createParameterTree(  );
        else{
            return this->IParameterized::createParameterTree(  );
        }
    }
    
    ::ParameterPool * default_createParameterTree(  ) const  {
        return IParameterized::createParameterTree( );
    }

    virtual double getRadius(  ) const  {
        if( bp::override func_getRadius = this->get_override( "getRadius" ) )
            return func_getRadius(  );
        else{
            return this->IFormFactor::getRadius(  );
        }
    }
    
    double default_getRadius(  ) const  {
        return IFormFactor::getRadius( );
    }

    virtual bool isDistributedFormFactor(  ) const  {
        if( bp::override func_isDistributedFormFactor = this->get_override( "isDistributedFormFactor" ) )
            return func_isDistributedFormFactor(  );
        else{
            return this->IFormFactor::isDistributedFormFactor(  );
        }
    }
    
    bool default_isDistributedFormFactor(  ) const  {
        return IFormFactor::isDistributedFormFactor( );
    }

    virtual void print_structure(  ) {
        if( bp::override func_print_structure = this->get_override( "print_structure" ) )
            func_print_structure(  );
        else{
            this->ISample::print_structure(  );
        }
    }
    
    void default_print_structure(  ) {
        ISample::print_structure( );
    }

    virtual void setAmbientRefractiveIndex( ::complex_t refractive_index ) {
        if( bp::override func_setAmbientRefractiveIndex = this->get_override( "setAmbientRefractiveIndex" ) )
            func_setAmbientRefractiveIndex( refractive_index );
        else{
            this->IFormFactor::setAmbientRefractiveIndex( refractive_index );
        }
    }
    
    void default_setAmbientRefractiveIndex( ::complex_t refractive_index ) {
        IFormFactor::setAmbientRefractiveIndex( refractive_index );
    }

};

struct FormFactorSphereGaussianRadius_wrapper : FormFactorSphereGaussianRadius, bp::wrapper< FormFactorSphereGaussianRadius > {

    FormFactorSphereGaussianRadius_wrapper(FormFactorSphereGaussianRadius const & arg )
    : FormFactorSphereGaussianRadius( arg )
      , bp::wrapper< FormFactorSphereGaussianRadius >(){
        // copy constructor
        
    }

    FormFactorSphereGaussianRadius_wrapper(double mean, double sigma )
    : FormFactorSphereGaussianRadius( mean, sigma )
      , bp::wrapper< FormFactorSphereGaussianRadius >(){
        // constructor
    
    }

    virtual ::FormFactorSphereGaussianRadius * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->FormFactorSphereGaussianRadius::clone(  );
        }
    }
    
    ::FormFactorSphereGaussianRadius * default_clone(  ) const  {
        return FormFactorSphereGaussianRadius::clone( );
    }

    virtual double getHeight(  ) const  {
        if( bp::override func_getHeight = this->get_override( "getHeight" ) )
            return func_getHeight(  );
        else{
            return this->FormFactorSphereGaussianRadius::getHeight(  );
        }
    }
    
    double default_getHeight(  ) const  {
        return FormFactorSphereGaussianRadius::getHeight( );
    }

    virtual int getNumberOfStochasticParameters(  ) const  {
        if( bp::override func_getNumberOfStochasticParameters = this->get_override( "getNumberOfStochasticParameters" ) )
            return func_getNumberOfStochasticParameters(  );
        else{
            return this->FormFactorSphereGaussianRadius::getNumberOfStochasticParameters(  );
        }
    }
    
    int default_getNumberOfStochasticParameters(  ) const  {
        return FormFactorSphereGaussianRadius::getNumberOfStochasticParameters( );
    }

    virtual bool isDistributedFormFactor(  ) const  {
        if( bp::override func_isDistributedFormFactor = this->get_override( "isDistributedFormFactor" ) )
            return func_isDistributedFormFactor(  );
        else{
            return this->FormFactorSphereGaussianRadius::isDistributedFormFactor(  );
        }
    }
    
    bool default_isDistributedFormFactor(  ) const  {
        return FormFactorSphereGaussianRadius::isDistributedFormFactor( );
    }

    virtual ::ParameterPool * createParameterTree(  ) const  {
        if( bp::override func_createParameterTree = this->get_override( "createParameterTree" ) )
            return func_createParameterTree(  );
        else{
            return this->IParameterized::createParameterTree(  );
        }
    }
    
    ::ParameterPool * default_createParameterTree(  ) const  {
        return IParameterized::createParameterTree( );
    }

    virtual double getRadius(  ) const  {
        if( bp::override func_getRadius = this->get_override( "getRadius" ) )
            return func_getRadius(  );
        else{
            return this->IFormFactor::getRadius(  );
        }
    }
    
    double default_getRadius(  ) const  {
        return IFormFactor::getRadius( );
    }

    virtual void print_structure(  ) {
        if( bp::override func_print_structure = this->get_override( "print_structure" ) )
            func_print_structure(  );
        else{
            this->ISample::print_structure(  );
        }
    }
    
    void default_print_structure(  ) {
        ISample::print_structure( );
    }

    virtual void setAmbientRefractiveIndex( ::complex_t refractive_index ) {
        if( bp::override func_setAmbientRefractiveIndex = this->get_override( "setAmbientRefractiveIndex" ) )
            func_setAmbientRefractiveIndex( refractive_index );
        else{
            this->IFormFactor::setAmbientRefractiveIndex( refractive_index );
        }
    }
    
    void default_setAmbientRefractiveIndex( ::complex_t refractive_index ) {
        IFormFactor::setAmbientRefractiveIndex( refractive_index );
    }

};

struct GISASExperiment_wrapper : GISASExperiment, bp::wrapper< GISASExperiment > {

    GISASExperiment_wrapper( )
    : GISASExperiment( )
      , bp::wrapper< GISASExperiment >(){
        // null constructor
    
    }

    virtual ::GISASExperiment * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->GISASExperiment::clone(  );
        }
    }
    
    ::GISASExperiment * default_clone(  ) const  {
        return GISASExperiment::clone( );
    }

    virtual void normalize(  ) {
        if( bp::override func_normalize = this->get_override( "normalize" ) )
            func_normalize(  );
        else{
            this->GISASExperiment::normalize(  );
        }
    }
    
    void default_normalize(  ) {
        GISASExperiment::normalize( );
    }

    virtual void runSimulation(  ) {
        if( bp::override func_runSimulation = this->get_override( "runSimulation" ) )
            func_runSimulation(  );
        else{
            this->GISASExperiment::runSimulation(  );
        }
    }
    
    void default_runSimulation(  ) {
        GISASExperiment::runSimulation( );
    }

    virtual ::ParameterPool * createParameterTree(  ) const  {
        if( bp::override func_createParameterTree = this->get_override( "createParameterTree" ) )
            return func_createParameterTree(  );
        else{
            return this->IParameterized::createParameterTree(  );
        }
    }
    
    ::ParameterPool * default_createParameterTree(  ) const  {
        return IParameterized::createParameterTree( );
    }

};

void register_classes_2(){

    bp::class_< FormFactorPyramid_wrapper, boost::noncopyable >( "FormFactorPyramid", bp::init< double, double, double >(( bp::arg("height"), bp::arg("half_side"), bp::arg("alpha") )) )    
        .def( 
            "clone"
            , (::FormFactorPyramid * ( ::FormFactorPyramid::* )(  ) const)(&::FormFactorPyramid::clone)
            , (::FormFactorPyramid * ( FormFactorPyramid_wrapper::* )(  ) const)(&FormFactorPyramid_wrapper::default_clone)
            , bp::return_value_policy< bp::manage_new_object >() )    
        .def( 
            "getHeight"
            , (double ( ::FormFactorPyramid::* )(  ) const)(&::FormFactorPyramid::getHeight)
            , (double ( FormFactorPyramid_wrapper::* )(  ) const)(&FormFactorPyramid_wrapper::default_getHeight) )    
        .def( 
            "getNumberOfStochasticParameters"
            , (int ( ::FormFactorPyramid::* )(  ) const)(&::FormFactorPyramid::getNumberOfStochasticParameters)
            , (int ( FormFactorPyramid_wrapper::* )(  ) const)(&FormFactorPyramid_wrapper::default_getNumberOfStochasticParameters) )    
        .def( 
            "createDistributedFormFactors"
            , (void ( ::IFormFactor::* )( ::std::vector< IFormFactor* > &,::std::vector< double > &,::size_t ) const)(&::IFormFactor::createDistributedFormFactors)
            , (void ( FormFactorPyramid_wrapper::* )( ::std::vector< IFormFactor* > &,::std::vector< double > &,::size_t ) const)(&FormFactorPyramid_wrapper::default_createDistributedFormFactors)
            , ( bp::arg("form_factors"), bp::arg("probabilities"), bp::arg("nbr_samples") )
            , bp::return_value_policy< bp::manage_new_object >() )    
        .def( 
            "createParameterTree"
            , (::ParameterPool * ( ::IParameterized::* )(  ) const)(&::IParameterized::createParameterTree)
            , (::ParameterPool * ( FormFactorPyramid_wrapper::* )(  ) const)(&FormFactorPyramid_wrapper::default_createParameterTree)
            , bp::return_value_policy< bp::manage_new_object >() )    
        .def( 
            "getRadius"
            , (double ( ::IFormFactor::* )(  ) const)(&::IFormFactor::getRadius)
            , (double ( FormFactorPyramid_wrapper::* )(  ) const)(&FormFactorPyramid_wrapper::default_getRadius) )    
        .def( 
            "isDistributedFormFactor"
            , (bool ( ::IFormFactor::* )(  ) const)(&::IFormFactor::isDistributedFormFactor)
            , (bool ( FormFactorPyramid_wrapper::* )(  ) const)(&FormFactorPyramid_wrapper::default_isDistributedFormFactor) )    
        .def( 
            "print_structure"
            , (void ( ::ISample::* )(  ) )(&::ISample::print_structure)
            , (void ( FormFactorPyramid_wrapper::* )(  ) )(&FormFactorPyramid_wrapper::default_print_structure) )    
        .def( 
            "setAmbientRefractiveIndex"
            , (void ( ::IFormFactor::* )( ::complex_t ) )(&::IFormFactor::setAmbientRefractiveIndex)
            , (void ( FormFactorPyramid_wrapper::* )( ::complex_t ) )(&FormFactorPyramid_wrapper::default_setAmbientRefractiveIndex)
            , ( bp::arg("refractive_index") ) );

    bp::class_< FormFactorSphereGaussianRadius_wrapper >( "FormFactorSphereGaussianRadius", bp::init< double, double >(( bp::arg("mean"), bp::arg("sigma") )) )    
        .def( 
            "clone"
            , (::FormFactorSphereGaussianRadius * ( ::FormFactorSphereGaussianRadius::* )(  ) const)(&::FormFactorSphereGaussianRadius::clone)
            , (::FormFactorSphereGaussianRadius * ( FormFactorSphereGaussianRadius_wrapper::* )(  ) const)(&FormFactorSphereGaussianRadius_wrapper::default_clone)
            , bp::return_value_policy< bp::manage_new_object >() )    
        .def( 
            "getHeight"
            , (double ( ::FormFactorSphereGaussianRadius::* )(  ) const)(&::FormFactorSphereGaussianRadius::getHeight)
            , (double ( FormFactorSphereGaussianRadius_wrapper::* )(  ) const)(&FormFactorSphereGaussianRadius_wrapper::default_getHeight) )    
        .def( 
            "getNumberOfStochasticParameters"
            , (int ( ::FormFactorSphereGaussianRadius::* )(  ) const)(&::FormFactorSphereGaussianRadius::getNumberOfStochasticParameters)
            , (int ( FormFactorSphereGaussianRadius_wrapper::* )(  ) const)(&FormFactorSphereGaussianRadius_wrapper::default_getNumberOfStochasticParameters) )    
        .def( 
            "isDistributedFormFactor"
            , (bool ( ::FormFactorSphereGaussianRadius::* )(  ) const)(&::FormFactorSphereGaussianRadius::isDistributedFormFactor)
            , (bool ( FormFactorSphereGaussianRadius_wrapper::* )(  ) const)(&FormFactorSphereGaussianRadius_wrapper::default_isDistributedFormFactor) )    
        .def( 
            "createParameterTree"
            , (::ParameterPool * ( ::IParameterized::* )(  ) const)(&::IParameterized::createParameterTree)
            , (::ParameterPool * ( FormFactorSphereGaussianRadius_wrapper::* )(  ) const)(&FormFactorSphereGaussianRadius_wrapper::default_createParameterTree)
            , bp::return_value_policy< bp::manage_new_object >() )    
        .def( 
            "getRadius"
            , (double ( ::IFormFactor::* )(  ) const)(&::IFormFactor::getRadius)
            , (double ( FormFactorSphereGaussianRadius_wrapper::* )(  ) const)(&FormFactorSphereGaussianRadius_wrapper::default_getRadius) )    
        .def( 
            "print_structure"
            , (void ( ::ISample::* )(  ) )(&::ISample::print_structure)
            , (void ( FormFactorSphereGaussianRadius_wrapper::* )(  ) )(&FormFactorSphereGaussianRadius_wrapper::default_print_structure) )    
        .def( 
            "setAmbientRefractiveIndex"
            , (void ( ::IFormFactor::* )( ::complex_t ) )(&::IFormFactor::setAmbientRefractiveIndex)
            , (void ( FormFactorSphereGaussianRadius_wrapper::* )( ::complex_t ) )(&FormFactorSphereGaussianRadius_wrapper::default_setAmbientRefractiveIndex)
            , ( bp::arg("refractive_index") ) );

    bp::class_< GISASExperiment_wrapper, bp::bases< Experiment >, boost::noncopyable >( "GISASExperiment", bp::init< >() )    
        .def( 
            "clone"
            , (::GISASExperiment * ( ::GISASExperiment::* )(  ) const)(&::GISASExperiment::clone)
            , (::GISASExperiment * ( GISASExperiment_wrapper::* )(  ) const)(&GISASExperiment_wrapper::default_clone)
            , bp::return_value_policy< bp::manage_new_object >() )    
        .def( 
            "normalize"
            , (void ( ::GISASExperiment::* )(  ) )(&::GISASExperiment::normalize)
            , (void ( GISASExperiment_wrapper::* )(  ) )(&GISASExperiment_wrapper::default_normalize) )    
        .def( 
            "runSimulation"
            , (void ( ::GISASExperiment::* )(  ) )(&::GISASExperiment::runSimulation)
            , (void ( GISASExperiment_wrapper::* )(  ) )(&GISASExperiment_wrapper::default_runSimulation) )    
        .def( 
            "setDetectorParameters"
            , (void ( ::GISASExperiment::* )( ::size_t,double,double,::size_t,double,double,bool ) )( &::GISASExperiment::setDetectorParameters )
            , ( bp::arg("n_phi"), bp::arg("phi_f_min"), bp::arg("phi_f_max"), bp::arg("n_alpha"), bp::arg("alpha_f_min"), bp::arg("alpha_f_max"), bp::arg("isgisaxs_style")=(bool)(false) ) )    
        .def( 
            "smearIntensityFromZAxisTilting"
            , (void ( ::GISASExperiment::* )(  ) )( &::GISASExperiment::smearIntensityFromZAxisTilting ) )    
        .def( 
            "createParameterTree"
            , (::ParameterPool * ( ::IParameterized::* )(  ) const)(&::IParameterized::createParameterTree)
            , (::ParameterPool * ( GISASExperiment_wrapper::* )(  ) const)(&GISASExperiment_wrapper::default_createParameterTree)
            , bp::return_value_policy< bp::manage_new_object >() );

    { //::Geometry::BasicVector3D< double >
        typedef bp::class_< Geometry::BasicVector3D< double > > kvector_t_exposer_t;
        kvector_t_exposer_t kvector_t_exposer = kvector_t_exposer_t( "kvector_t", bp::init< >() );
        bp::scope kvector_t_scope( kvector_t_exposer );
        bp::scope().attr("X") = (int)Geometry::BasicVector3D<double>::X;
        bp::scope().attr("Y") = (int)Geometry::BasicVector3D<double>::Y;
        bp::scope().attr("Z") = (int)Geometry::BasicVector3D<double>::Z;
        bp::scope().attr("NUM_COORDINATES") = (int)Geometry::BasicVector3D<double>::NUM_COORDINATES;
        bp::scope().attr("SIZE") = (int)Geometry::BasicVector3D<double>::SIZE;
        kvector_t_exposer.def( bp::init< double, double, double >(( bp::arg("x1"), bp::arg("y1"), bp::arg("z1") )) );
        { //::Geometry::BasicVector3D< double >::angle
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*angle_function_type )( ::Geometry::BasicVector3D< double > const & ) const;
            
            kvector_t_exposer.def( 
                "angle"
                , angle_function_type( &::Geometry::BasicVector3D< double >::angle )
                , ( bp::arg("v") ) );
        
        }
        { //::Geometry::BasicVector3D< double >::cosTheta
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*cosTheta_function_type )(  ) const;
            
            kvector_t_exposer.def( 
                "cosTheta"
                , cosTheta_function_type( &::Geometry::BasicVector3D< double >::cosTheta ) );
        
        }
        { //::Geometry::BasicVector3D< double >::cross
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef ::Geometry::BasicVector3D< double > ( exported_class_t::*cross_function_type )( ::Geometry::BasicVector3D< double > const & ) const;
            
            kvector_t_exposer.def( 
                "cross"
                , cross_function_type( &::Geometry::BasicVector3D< double >::cross )
                , ( bp::arg("v") ) );
        
        }
        { //::Geometry::BasicVector3D< double >::dot
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*dot_function_type )( ::Geometry::BasicVector3D< double > const & ) const;
            
            kvector_t_exposer.def( 
                "dot"
                , dot_function_type( &::Geometry::BasicVector3D< double >::dot )
                , ( bp::arg("v") ) );
        
        }
        { //::Geometry::BasicVector3D< double >::getPhi
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*getPhi_function_type )(  ) const;
            
            kvector_t_exposer.def( 
                "getPhi"
                , getPhi_function_type( &::Geometry::BasicVector3D< double >::getPhi ) );
        
        }
        { //::Geometry::BasicVector3D< double >::getR
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*getR_function_type )(  ) const;
            
            kvector_t_exposer.def( 
                "getR"
                , getR_function_type( &::Geometry::BasicVector3D< double >::getR ) );
        
        }
        { //::Geometry::BasicVector3D< double >::getTheta
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*getTheta_function_type )(  ) const;
            
            kvector_t_exposer.def( 
                "getTheta"
                , getTheta_function_type( &::Geometry::BasicVector3D< double >::getTheta ) );
        
        }
        { //::Geometry::BasicVector3D< double >::mag
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*mag_function_type )(  ) const;
            
            kvector_t_exposer.def( 
                "mag"
                , mag_function_type( &::Geometry::BasicVector3D< double >::mag ) );
        
        }
        { //::Geometry::BasicVector3D< double >::mag2
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*mag2_function_type )(  ) const;
            
            kvector_t_exposer.def( 
                "mag2"
                , mag2_function_type( &::Geometry::BasicVector3D< double >::mag2 ) );
        
        }
        { //::Geometry::BasicVector3D< double >::magxy
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*magxy_function_type )(  ) const;
            
            kvector_t_exposer.def( 
                "magxy"
                , magxy_function_type( &::Geometry::BasicVector3D< double >::magxy ) );
        
        }
        kvector_t_exposer.def( bp::self *= bp::other< double >() );
        kvector_t_exposer.def( bp::self += bp::self );
        kvector_t_exposer.def( bp::self -= bp::self );
        kvector_t_exposer.def( bp::self /= bp::other< double >() );
        { //::Geometry::BasicVector3D< double >::operator=
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef ::Geometry::BasicVector3D< double > & ( exported_class_t::*assign_function_type )( ::Geometry::BasicVector3D< double > const & ) ;
            
            kvector_t_exposer.def( 
                "assign"
                , assign_function_type( &::Geometry::BasicVector3D< double >::operator= )
                , ( bp::arg("v") )
                , bp::return_self< >() );
        
        }
        { //::Geometry::BasicVector3D< double >::operator[]
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*__getitem___function_type )( int ) const;
            
            kvector_t_exposer.def( 
                "__getitem__"
                , __getitem___function_type( &::Geometry::BasicVector3D< double >::operator[] )
                , ( bp::arg("i") ) );
        
        }
        { //::Geometry::BasicVector3D< double >::operator[]
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double & ( exported_class_t::*__getitem___function_type )( int ) ;
            
            kvector_t_exposer.def( 
                "__getitem__"
                , __getitem___function_type( &::Geometry::BasicVector3D< double >::operator[] )
                , ( bp::arg("i") )
                , bp::return_value_policy< bp::copy_non_const_reference >() );
        
        }
        { //::Geometry::BasicVector3D< double >::orthogonal
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef ::Geometry::BasicVector3D< double > ( exported_class_t::*orthogonal_function_type )(  ) const;
            
            kvector_t_exposer.def( 
                "orthogonal"
                , orthogonal_function_type( &::Geometry::BasicVector3D< double >::orthogonal ) );
        
        }
        { //::Geometry::BasicVector3D< double >::perp
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*perp_function_type )(  ) const;
            
            kvector_t_exposer.def( 
                "perp"
                , perp_function_type( &::Geometry::BasicVector3D< double >::perp ) );
        
        }
        { //::Geometry::BasicVector3D< double >::perp
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*perp_function_type )( ::Geometry::BasicVector3D< double > const & ) const;
            
            kvector_t_exposer.def( 
                "perp"
                , perp_function_type( &::Geometry::BasicVector3D< double >::perp )
                , ( bp::arg("v") ) );
        
        }
        { //::Geometry::BasicVector3D< double >::perp2
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*perp2_function_type )(  ) const;
            
            kvector_t_exposer.def( 
                "perp2"
                , perp2_function_type( &::Geometry::BasicVector3D< double >::perp2 ) );
        
        }
        { //::Geometry::BasicVector3D< double >::perp2
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*perp2_function_type )( ::Geometry::BasicVector3D< double > const & ) const;
            
            kvector_t_exposer.def( 
                "perp2"
                , perp2_function_type( &::Geometry::BasicVector3D< double >::perp2 )
                , ( bp::arg("v") ) );
        
        }
        { //::Geometry::BasicVector3D< double >::phi
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*phi_function_type )(  ) const;
            
            kvector_t_exposer.def( 
                "phi"
                , phi_function_type( &::Geometry::BasicVector3D< double >::phi ) );
        
        }
        { //::Geometry::BasicVector3D< double >::r
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*r_function_type )(  ) const;
            
            kvector_t_exposer.def( 
                "r"
                , r_function_type( &::Geometry::BasicVector3D< double >::r ) );
        
        }
        { //::Geometry::BasicVector3D< double >::rho
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*rho_function_type )(  ) const;
            
            kvector_t_exposer.def( 
                "rho"
                , rho_function_type( &::Geometry::BasicVector3D< double >::rho ) );
        
        }
        { //::Geometry::BasicVector3D< double >::rotate
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef ::Geometry::BasicVector3D< double > & ( exported_class_t::*rotate_function_type )( double,::Geometry::BasicVector3D< double > const & ) ;
            
            kvector_t_exposer.def( 
                "rotate"
                , rotate_function_type( &::Geometry::BasicVector3D< double >::rotate )
                , ( bp::arg("a"), bp::arg("v") )
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::Geometry::BasicVector3D< double >::rotateX
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef ::Geometry::BasicVector3D< double > & ( exported_class_t::*rotateX_function_type )( double ) ;
            
            kvector_t_exposer.def( 
                "rotateX"
                , rotateX_function_type( &::Geometry::BasicVector3D< double >::rotateX )
                , ( bp::arg("a") )
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::Geometry::BasicVector3D< double >::rotateY
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef ::Geometry::BasicVector3D< double > & ( exported_class_t::*rotateY_function_type )( double ) ;
            
            kvector_t_exposer.def( 
                "rotateY"
                , rotateY_function_type( &::Geometry::BasicVector3D< double >::rotateY )
                , ( bp::arg("a") )
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::Geometry::BasicVector3D< double >::rotateZ
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef ::Geometry::BasicVector3D< double > & ( exported_class_t::*rotateZ_function_type )( double ) ;
            
            kvector_t_exposer.def( 
                "rotateZ"
                , rotateZ_function_type( &::Geometry::BasicVector3D< double >::rotateZ )
                , ( bp::arg("a") )
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::Geometry::BasicVector3D< double >::set
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef void ( exported_class_t::*set_function_type )( double,double,double ) ;
            
            kvector_t_exposer.def( 
                "set"
                , set_function_type( &::Geometry::BasicVector3D< double >::set )
                , ( bp::arg("x1"), bp::arg("y1"), bp::arg("z1") ) );
        
        }
        { //::Geometry::BasicVector3D< double >::setLambdaAlphaPhi
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef void ( exported_class_t::*setLambdaAlphaPhi_function_type )( double,double,double ) ;
            
            kvector_t_exposer.def( 
                "setLambdaAlphaPhi"
                , setLambdaAlphaPhi_function_type( &::Geometry::BasicVector3D< double >::setLambdaAlphaPhi )
                , ( bp::arg("lambda"), bp::arg("alpha"), bp::arg("phi") ) );
        
        }
        { //::Geometry::BasicVector3D< double >::setMag
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef void ( exported_class_t::*setMag_function_type )( double ) ;
            
            kvector_t_exposer.def( 
                "setMag"
                , setMag_function_type( &::Geometry::BasicVector3D< double >::setMag )
                , ( bp::arg("ma") ) );
        
        }
        { //::Geometry::BasicVector3D< double >::setPerp
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef void ( exported_class_t::*setPerp_function_type )( double ) ;
            
            kvector_t_exposer.def( 
                "setPerp"
                , setPerp_function_type( &::Geometry::BasicVector3D< double >::setPerp )
                , ( bp::arg("rh") ) );
        
        }
        { //::Geometry::BasicVector3D< double >::setPhi
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef void ( exported_class_t::*setPhi_function_type )( double ) ;
            
            kvector_t_exposer.def( 
                "setPhi"
                , setPhi_function_type( &::Geometry::BasicVector3D< double >::setPhi )
                , ( bp::arg("ph") ) );
        
        }
        { //::Geometry::BasicVector3D< double >::setR
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef void ( exported_class_t::*setR_function_type )( double ) ;
            
            kvector_t_exposer.def( 
                "setR"
                , setR_function_type( &::Geometry::BasicVector3D< double >::setR )
                , ( bp::arg("ma") ) );
        
        }
        { //::Geometry::BasicVector3D< double >::setTheta
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef void ( exported_class_t::*setTheta_function_type )( double ) ;
            
            kvector_t_exposer.def( 
                "setTheta"
                , setTheta_function_type( &::Geometry::BasicVector3D< double >::setTheta )
                , ( bp::arg("th") ) );
        
        }
        { //::Geometry::BasicVector3D< double >::setX
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef void ( exported_class_t::*setX_function_type )( double ) ;
            
            kvector_t_exposer.def( 
                "setX"
                , setX_function_type( &::Geometry::BasicVector3D< double >::setX )
                , ( bp::arg("a") ) );
        
        }
        { //::Geometry::BasicVector3D< double >::setXYZ
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef void ( exported_class_t::*setXYZ_function_type )( double,double,double ) ;
            
            kvector_t_exposer.def( 
                "setXYZ"
                , setXYZ_function_type( &::Geometry::BasicVector3D< double >::setXYZ )
                , ( bp::arg("x1"), bp::arg("y1"), bp::arg("z1") ) );
        
        }
        { //::Geometry::BasicVector3D< double >::setY
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef void ( exported_class_t::*setY_function_type )( double ) ;
            
            kvector_t_exposer.def( 
                "setY"
                , setY_function_type( &::Geometry::BasicVector3D< double >::setY )
                , ( bp::arg("a") ) );
        
        }
        { //::Geometry::BasicVector3D< double >::setZ
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef void ( exported_class_t::*setZ_function_type )( double ) ;
            
            kvector_t_exposer.def( 
                "setZ"
                , setZ_function_type( &::Geometry::BasicVector3D< double >::setZ )
                , ( bp::arg("a") ) );
        
        }
        { //::Geometry::BasicVector3D< double >::theta
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*theta_function_type )(  ) const;
            
            kvector_t_exposer.def( 
                "theta"
                , theta_function_type( &::Geometry::BasicVector3D< double >::theta ) );
        
        }
        { //::Geometry::BasicVector3D< double >::transform
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef ::Geometry::BasicVector3D< double > & ( exported_class_t::*transform_function_type )( ::Geometry::Transform3D const & ) ;
            
            kvector_t_exposer.def( 
                "transform"
                , transform_function_type( &::Geometry::BasicVector3D< double >::transform )
                , ( bp::arg("m") )
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::Geometry::BasicVector3D< double >::unit
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef ::Geometry::BasicVector3D< double > ( exported_class_t::*unit_function_type )(  ) const;
            
            kvector_t_exposer.def( 
                "unit"
                , unit_function_type( &::Geometry::BasicVector3D< double >::unit ) );
        
        }
        { //::Geometry::BasicVector3D< double >::x
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*x_function_type )(  ) const;
            
            kvector_t_exposer.def( 
                "x"
                , x_function_type( &::Geometry::BasicVector3D< double >::x ) );
        
        }
        { //::Geometry::BasicVector3D< double >::y
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*y_function_type )(  ) const;
            
            kvector_t_exposer.def( 
                "y"
                , y_function_type( &::Geometry::BasicVector3D< double >::y ) );
        
        }
        { //::Geometry::BasicVector3D< double >::z
        
            typedef Geometry::BasicVector3D< double > exported_class_t;
            typedef double ( exported_class_t::*z_function_type )(  ) const;
            
            kvector_t_exposer.def( 
                "z"
                , z_function_type( &::Geometry::BasicVector3D< double >::z ) );
        
        }
        kvector_t_exposer.def( bp::self != bp::self );
        kvector_t_exposer.def( bp::other< double >() * bp::self );
        kvector_t_exposer.def( bp::self * bp::self );
        kvector_t_exposer.def( bp::self * bp::other< double >() );
        kvector_t_exposer.def( bp::self + bp::self );
        kvector_t_exposer.def( +bp::self );
        kvector_t_exposer.def( bp::self - bp::self );
        kvector_t_exposer.def( -bp::self );
        kvector_t_exposer.def( bp::self / bp::other< double >() );
        kvector_t_exposer.def( bp::self_ns::str( bp::self ) );
        kvector_t_exposer.def( bp::self == bp::self );
    }

    bp::class_< Geometry::Reflect3D, bp::bases< Geometry::Transform3D > >( "Reflect3D", bp::init< >() )    
        .def( bp::init< double, double, double, double >(( bp::arg("a"), bp::arg("b"), bp::arg("c"), bp::arg("d") )) );

    bp::class_< Geometry::ReflectX3D, bp::bases< Geometry::Reflect3D > >( "ReflectX3D", bp::init< bp::optional< double > >(( bp::arg("x")=0 )) );

    bp::class_< Geometry::ReflectY3D, bp::bases< Geometry::Reflect3D > >( "ReflectY3D", bp::init< bp::optional< double > >(( bp::arg("y")=0 )) );

    bp::class_< Geometry::ReflectZ3D, bp::bases< Geometry::Reflect3D > >( "ReflectZ3D", bp::init< bp::optional< double > >(( bp::arg("z")=0 )) );

    bp::class_< Geometry::Rotate3D, bp::bases< Geometry::Transform3D > >( "Rotate3D", bp::init< >() );

    bp::class_< Geometry::RotateX3D, bp::bases< Geometry::Rotate3D > >( "RotateX3D", bp::init< >() )    
        .def( bp::init< double >(( bp::arg("a") )) );

    bp::class_< Geometry::RotateY3D, bp::bases< Geometry::Rotate3D > >( "RotateY3D", bp::init< >() )    
        .def( bp::init< double >(( bp::arg("a") )) );

    bp::class_< Geometry::RotateZ3D, bp::bases< Geometry::Rotate3D > >( "RotateZ3D", bp::init< >() )    
        .def( bp::init< double >(( bp::arg("a") )) );

    bp::class_< Geometry::Scale3D, bp::bases< Geometry::Transform3D > >( "Scale3D", bp::init< >() )    
        .def( bp::init< double, double, double >(( bp::arg("x"), bp::arg("y"), bp::arg("z") )) )    
        .def( bp::init< double >(( bp::arg("s") )) );

    bp::class_< Geometry::ScaleX3D, bp::bases< Geometry::Scale3D > >( "ScaleX3D", bp::init< >() )    
        .def( bp::init< double >(( bp::arg("x") )) );

    bp::class_< Geometry::ScaleY3D, bp::bases< Geometry::Scale3D > >( "ScaleY3D", bp::init< >() )    
        .def( bp::init< double >(( bp::arg("y") )) );

    bp::class_< Geometry::ScaleZ3D, bp::bases< Geometry::Scale3D > >( "ScaleZ3D", bp::init< >() )    
        .def( bp::init< double >(( bp::arg("z") )) );

    bp::class_< Geometry::Translate3D, bp::bases< Geometry::Transform3D > >( "Translate3D", bp::init< >() )    
        .def( bp::init< double, double, double >(( bp::arg("x"), bp::arg("y"), bp::arg("z") )) );

    bp::class_< Geometry::TranslateX3D, bp::bases< Geometry::Translate3D > >( "TranslateX3D", bp::init< >() )    
        .def( bp::init< double >(( bp::arg("x") )) );

    bp::class_< Geometry::TranslateY3D, bp::bases< Geometry::Translate3D > >( "TranslateY3D", bp::init< >() )    
        .def( bp::init< double >(( bp::arg("y") )) );

    bp::class_< Geometry::TranslateZ3D, bp::bases< Geometry::Translate3D > >( "TranslateZ3D", bp::init< >() )    
        .def( bp::init< double >(( bp::arg("z") )) );

}
