#include "ICompositeSample.h"
#include "ICompositeIterator.h"
#include "Utils.h"
#include <vector>
#include <sstream>



ICompositeSample::ICompositeSample()
{

}


ICompositeSample::ICompositeSample(const ICompositeSample &other) : ISample(other)
{

}


/* ************************************************************************* */
// register child in the container
/* ************************************************************************* */
void ICompositeSample::registerChild(ISample *sample)
{
    if(sample) {
        m_samples.push_back(sample);
    } else {
        std::cout << "ICompositeSample::registerChild() -> Error! Attempt to register NULL child in this " << *this << std::endl;
    }
}


/* ************************************************************************* */
// remove registere child from the container
/* ************************************************************************* */
void ICompositeSample::deregisterChild(ISample *sample)
{
    m_samples.remove(sample);
}


/* ************************************************************************* */
// create general iterator to walk through the tree of registered composite children
/* ************************************************************************* */
ICompositeIterator ICompositeSample::createIterator()
{
    return ICompositeIterator(this);
}

